Minutes from 128-th OpenVDB TSC meeting, April 5th, 2022, (EDT)

Attendees: *Ken* M., *Jeff* L., *Nick* A., *Rich* J., *Andre* P.

Additional Attendees: Kyle Wardlow, Karl Marrett (UCLA), Bruce Cherniak (Intel)
Sebastian Gaida, Greg Hurst (United Therapeutics), J. T. Nelson (Blender)

Regrets: *Dan* B.

Agenda:

1) Confirm quorum
2) Secretary
3) Forum
4) Half Implementation
5) PR-1347: Meeting Notes
6) PR-1343: Speed up Windows CI
7) PR-1342: MinGW fix
8) PR-1339: Meeting notes and consolidate pending-changes
9) PR-1336: Exposed TypeLists of the default set of OpenVDB types
10) PR-1333: Small CMake change
11) PR-1008: Rasterization
12) PR-1317: openvdb_tool
13) OpenVDBLink: Link between Mathematica and OpenVDB
14) USD
15) Next Meeting

--------------------

1) Confirm quorum

Quorum is present.

2) Secretary

Secretary is Andre Pradhana.

3) Forum

a) Windows static build

Several Windows users have asked for a better CMake support, see e.g. Issue
[1160](https://github.com/AcademySoftwareFoundation/openvdb/issues/1160).

We need to improve the CMake support especially for a better use of OpenVDB
downstream. The CMake workflow should allow a user to easily bring VDB
library, its dependencies, and compiled-flags; which all depend on the
platform. This is primarily a Windows problem because Windows requires more
specific branching in CMake. We need a custom find-modules in our CMake and
rewrite the findPackage logic, e.g. findOpenVDB.cmake should not exist. This
can be replaced by an OpenVDBconfig.cmake file (config module) instead.

Ken asks if distributing binaries actually solves the problem. Nick thinks that
it can alleviate the problem, but not solve it.

Ken will bring this issue to the TAC meeting to ask for from other ASWF
projects on April 20th 2022.

b) Post in the forum about building VDB 9.0 with embedded half.

Jeff said that the user included both openvdb.lib and libopenvdb.lib, which
causes the problem.

4) Half Implementation

Ken is going to ask Autodesk about their requirements for a half-grid
implementation. Greg Hurst plans to spear-head the effort once he is done
with Mathematica-OpenVDBLink PR.

5) PR-1347: Meeting Notes

Somebody will take a look.

6) PR-1343: Speed up Windows CI

Adding Caching support for vcpckg installs, which should speed up the Windows
CI. Nick and Jeff are unsure about store password logic that the PR includes.
It would be nice if Dan takes a look.

7) PR-1342: MinGW fix

Nick is happy with this PR. Jeff approves.

8) PR-1339: Meeting notes and consolidate pending-changes

Merged.

9) PR-1336: Exposed TypeLists of the default set of OpenVDB types

This allows a user to do static-dispatch using a pre-approved list of grids
to be supported by an algorithm at compile time. At runtime, however, it still
does a string comparison. We could add an enum to replace the string
comparison logic.

We are happy to remove the Native keyword from the type-lists.

10) PR-1333: Small CMake change

Modernize CMake: change find_package(PythonLibs) to find_package(Python).

11) PR-1008: Rasterization

Rasterization PR from Nick. We have talked about approving both rasterization
PRs from Nick and Dan. Andre approves the PR.

12) PR-1317: openvdb_tool

Ken is pushing changes, including CMake. The PR is ready for some feedback.

13) OpenVDBLink: Link between Mathematica and OpenVDB

Greg will create a new branch containing OpenVDBLink, which provides a link
between OpenVDB and Wolfram Mathematica, and will create a PR based on it.

Greg ask about an advection example. Andre suggests to use Enright field to
advect a density field. Nick suggests to advect points with a curl noise.
Ken will help Greg.

14) USD

Bruce Cherniak raises awareness on an USD PR to [support OpenVDB without
depending on OpenEXR](https://github.com/PixarAnimationStudios/USD/pull/1728).

The PR is from NVIDIA Gameworks. Nick and Ken will take a look.

15) Next Meeting

Next meeting is in one week, April 12th, 2022. 1pm-2pm EST (GMT-5).
