Minutes from 130-th OpenVDB TSC meeting, April 26th, 2022, (EDT)

Attendees: *Jeff* L., *Nick* A, *Dan* B., *Rich* J., *Andre* P.

Additional Attendees: Sebastian Gaida, J. T. Nelson, Serjio Rojas,
Greg Hurst (United Therapeutics)

Regrets: *Ken* M.

Agenda:

1) Confirm quorum
2) Secretary
3) Forum
4) Explicit template instantiation using Typelist
5) Subfolders for implementation files
6) Greg Hurst update
7) Blosc 1.20
8) Dan pushed a PR on command line tool reorganization 
9) 9.1 Release
10) Changing the include paths to relative (PR-1363)
11) Next meeting

--------------------

1) Confirm quorum

Quorum is present.

2) Secretary

Secretary is Andre Pradhana.

3) Forum

a) NanoVDB issues

Nick mentions NanoVDB issues. He will redirect them to Ken.

b) Github Issue #161: Publish Python Library on PyPi

PyPi is a Python package service. Peyton Murray offered to help the OpenVDB
maintainers to automate the process of building and publishing on PyPi through
our CI. This means that OpenVDB TSC members will take over the ownership of
publishing pyopenvdb through PyPi. Peyton Murray offered to contact the
current owner on our behalf.

We require that publishing pyopenvdb through PyPi should happen automatically
through CI and not as another manual step in our release process. We all agree
to give Peyton Murray the green light.

4) Explicit template instantiation using Typelist

Nick demonstrates how to do explicit template instantiation using typelist. 
Dan comments that this compilation solution is better than writing macro. The
tricky part about explicit template instantiation is to deal with the
exceptions. Jeff likes Dan's solution for explicit template instantiation
because we can split up the .cc files according to each type to obtain more
parallelism in compilation process.

In talking about explicit template instantiation, we also discuss the problem
of circular dependencies that happen in Count.h. We need to solve this problem.)

5) Subfolders for implementation files

Nick targets the Point Rasterization PR that's been pushed. He adds a new
folder openvdb/points/impl that contains implementation files. Jeff suggests
appending the implementation files with 'Impl'.

6) Greg Hurst update

John Mertic gave a reply regarding the use of Free Engine in an open source
project. He said that we can use the Free Engine in developing the project,
and for demos and testing. It does not seem that we need an EULA for run unit
tests and build a binary to check compilation.

7) Blosc 1.20

Jeff asks if we can move to Blosc 1.20 for Houdini. Nick says yes. Nick tested
Blosc 1.17-1.21.

8) Dan pushed a PR on command line tool reorganization 

Dan pushed a PR on reorganization of command line tools. He did not get rid of
OpenVDB Build Binaries flag in this PR, which will be addressed in another PR. 

9) 9.1 Release

We plan to do a 9.1 release in early summer.

Deprecation warnings for Blosc should go into 9.1 release.

We expect Mathematica PR to go in for 10.0. We need to confirm with Ken
regarding the openvdb_tool release. 

We aim to release 9.1 for the end of May 2022.

10) Changing the include paths to relative (PR-1363)

Jeff and Nick mention a few cases where we need to change angle-brackets to
double quotes. Nick mentions the need to use double-quote when including
version.h. Sebastian Gaida will make these changes to the PR.

11) Next meeting

Next meeting is on May 3rd, 2022. 1pm-2pm EDT (GMT-4).
