Minutes from 153rd OpenVDB TSC meeting, November 1st, 2022

Attendees: *Jeff* L., *Andre* P, *Dan* B., *Ken* M.

Additional Attendees: Greg Hurst (United Therapeutics), Sebastian Gaida

Regrets: *Nick* A., *Rich* J.

Agenda:

1) Confirm quorum
2) Secretary
3) OpenVDB release
4) PyBindings 11
5) Audit of DCCs
6) File IO
7) VDB Max
8) CI
9) Next meeting

------------

1) Confirm quorum

Quorum is present.

2) Secretary

Secretary is Jeff Lait.
 
3) OpenVDB release

Success, thanks to Andre!  Mostly worked smootly, but we have to
remember to spell check changes.  It was very useful that we had
pre-run the weeklies.

A PR is present for the website update for Greg's help docs.

CHANGES.txt needs the 10.0.1 change and spell checking. 

Greg will post a intro tutorial on the Wolfram community when website
is updated.

We'll wait for Wolfram to okay with being listed as an adopter before
we add them to the adopter list.

We will not update example version numbers in the release check list.

4) PyBindings 11

Issue 1124.  matthewdcong is looking at building python bindings for
NVidia and plans on adding this to the OpenVDB.

ILM has boost::python but is a different approach.  But doesn't help
us move away from boost::python.

Hope is the new one would be good enough for ILM to eventually switch;
but their version probably is too deeply integrated to do.

Matthew should join and present his work so far and what we'd like it
to look like.  Eg, vdb_tool-like?

ILM has "VDB Group" - associated vdb primitives, like a velocity field
and distnace field.  Needs to be some mechanism to pair up/collate
VDBs.  Hard to integrate into Houdini where VDB are atomic.  Within a
group topology does not have to be shared, but by convention they
often are.  Groups are disjoint.   Could be a directory name per vdb.

5) Audit of DCCs

Larry Gritz has started a spreadsheet for how long things are
supported by various DCCs and what studios are still using.  We tend
to be on the leading edge in deprecating quickly.

Most are following VFX Platform and Houdini.  

6) File IO

Can we remove all the IO code from tree/Hierarchy into a separate
.h/.cc?  Then do all the IO through that mechanism.  This will make a
new file io easier.  Hopefully user still uses Archive, it just is
implemented elsewhere.  

This may require always initialization openvdb, even for writing.  A
lot of root node methods require an absolute coordinate, so makes
working with offsets very hard in the file io.  

Can friend be added without changing ABI?   

Plan is to remove support for the pre-open-source file formats.

Support for 1.0 on will remain.  Saving into the new format would be
opt-in, so people can use once their pipeline has migrated.

7) VDB Max

This is pending, has been tested internally and is ready to push up
soon.  Designed around fog volumes.  

8) CI

Are some of the machines disappearing soon?  At some point we have to
pay for these.  Goal is to use November stats to figure out how much
we have to pay for.  ASWF is tracking costs, but currently it is for
free.  Weekly CI outside of a release can use lower powered machines
as it is not critical.  There are GPU resources now available; we
might want to add GPU unit tests.

The latest weekly build cost 12 hours of billable compute.

9) Next meeting

Next meeting is on November 9th, 2022. 2pm-3pm EDT (GMT-4).
